#!/bin/bash
set -e
if [ ! -d test_output ]; then
    mkdir test_output
fi

perl build_cluster_script.pl -c 'qsub submit.sh -i input$.fa -o output$.fa' -o ./test_output/test_script_numbers.sh -n 50
perl build_cluster_script.pl -c 'qsub submit.sh -i input.fa_$ -o output.fa_$' -o ./test_output/test_script_letters.sh -n 50 -l
perl build_cluster_script.pl -c 'qsub submit.sh -i input.fa_$ -o output.fa_$' -o ./test_output/test_script_separate_numbers.sh -n 2 -s
perl build_cluster_script.pl -c 'qsub submit.sh -i input.fa_$ -o output.fa_$' -o ./test_output/test_script_separate_letters.sh -n 2 -l -s
perl build_cluster_script.pl -c 'perl some_script.pl -x 0.00000001 -b blastn -i input_$ -o output_$' -o ./test_output/run_perl_script_on_cluster.sh -n 50 -l -s
perl build_cluster_script.pl -c 'qsub -S /bin/sh -N $_job -j y -o standard_out_and_error_$ ./test_output/run_perl_script_on_cluster_$.sh' -o ./test_output/submit_jobs.sh -n 50 -l

#compare new output to sample output
new_output=test_output
old_output=sample_output
new_files=($( find $new_output -type f -print0 | perl -ne 'my @files = split(/\0/, $_); foreach(@files) { if (!($_ =~ m/\.svn/)) {print "$_\n";}}'))
for (( i=0; i<${#new_files[@]}; i++ ));
do
    old_file=${old_output}`echo "${new_files[$i]}" | perl -nl -e 's/^[^\/]+//;' -e 'print $_'`
    echo "Comparing ${old_file} to ${new_files[$i]}"
    set +e
    diff -u $old_file ${new_files[$i]}
    if [ $? -eq 0 ]; then
	echo "No differences found"
    fi
    set -e
done